#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <termios.h>


void m_setparms(int fd, char *baudr, char *par, char *bits, char *stopb, int hwf, int swf);



#define SERIALPORT "/dev/ttyUSB0"

int main (int argc, char **argv)
{
	int sfd;
	FILE *serial,*dfile;

	int line=1;

	char buff[1024];

	if (argc!=2) {
		printf("Usage: %s file.gcode\n",argv[0]);
		return 2;
	}

	dfile=fopen(argv[1],"r");
	if (!dfile) {
		printf("Failed opening gcode file %s, %s\n",argv[1],strerror(errno));
		return 3;
	}

	sfd=open(SERIALPORT,O_RDWR);
	if (sfd==-1) {
		printf("Failed opening serial port %s, %s\n",SERIALPORT,strerror(errno));
		return 3;
	}

	m_setparms(sfd, "19200","N","8","1",0,0);

	serial=fdopen(sfd,"r+");
	setlinebuf(serial);
	setlinebuf(dfile);

	printf("Please press reset on the device.\n");	
	fgets(buff,1024,serial);
	while (strstr(buff,"start")==NULL)
		fgets(buff,1024,serial);

	fgets(buff,1024,dfile);
	while (!feof(dfile)) {
		if (buff[0]==';') goto next;
		printf("Sending line %d: %s",line,buff);
		fprintf(serial,"%s",buff);
		fgets(buff,1024,serial);
		printf("Read for %d: %s",line,buff);
		while(buff[0]!='o') {
			fgets(buff,1024,serial);
			printf("Read %s",buff);
		}
next:
		line++;
		fgets(buff,1024,dfile);

	}

	fclose(dfile);
	close(sfd);
	return 0;

}
